/*******************************************************************************
* Copyright 2015-2021 Intel Corporation.
*
* This software and the related documents are Intel copyrighted  materials,  and
* your use of  them is  governed by the  express license  under which  they were
* provided to you (License).  Unless the License provides otherwise, you may not
* use, modify, copy, publish, distribute,  disclose or transmit this software or
* the related documents without Intel's prior written permission.
*
* This software and the related documents  are provided as  is,  with no express
* or implied  warranties,  other  than those  that are  expressly stated  in the
* License.
*******************************************************************************/

// A simple example of getting the library version using Intel(R) Integrated Primitives (Intel(R) IPP) function.

#include <stdio.h>
#include "ipp.h"

int main(void)
{
    const IppLibraryVersion *ippLib;
    ippLib = ippGetLibVersion();
    printf("  version: %s, [%d.%d.%d.%d] ", ippLib->Version, ippLib->major, ippLib->minor, ippLib->build, ippLib->majorBuild);
    printf("  name:    %s", ippLib->Name);
    printf("  date:    %s\n", ippLib->BuildDate);
    ippLib = ippiGetLibVersion();
    printf("  version: %s, [%d.%d.%d.%d] ", ippLib->Version, ippLib->major, ippLib->minor, ippLib->build, ippLib->majorBuild);
    printf("  name:    %s", ippLib->Name);
    printf("  date:    %s\n", ippLib->BuildDate);
    ippLib = ippsGetLibVersion();
    printf("  version: %s, [%d.%d.%d.%d] ", ippLib->Version, ippLib->major, ippLib->minor, ippLib->build, ippLib->majorBuild);
    printf("  name:    %s", ippLib->Name);
    printf("  date:    %s\n", ippLib->BuildDate);
    ippLib = ippccGetLibVersion();
    printf("  version: %s, [%d.%d.%d.%d] ", ippLib->Version, ippLib->major, ippLib->minor, ippLib->build, ippLib->majorBuild);
    printf("  name:    %s", ippLib->Name);
    printf("  date:    %s\n", ippLib->BuildDate);
    ippLib = ippchGetLibVersion();
    printf("  version: %s, [%d.%d.%d.%d] ", ippLib->Version, ippLib->major, ippLib->minor, ippLib->build, ippLib->majorBuild);
    printf("  name:    %s", ippLib->Name);
    printf("  date:    %s\n", ippLib->BuildDate);
    ippLib = ippvmGetLibVersion();
    printf("  version: %s, [%d.%d.%d.%d] ", ippLib->Version, ippLib->major, ippLib->minor, ippLib->build, ippLib->majorBuild);
    printf("  name:    %s", ippLib->Name);
    printf("  date:    %s\n", ippLib->BuildDate);
    ippLib = ippcvGetLibVersion();
    printf("  version: %s, [%d.%d.%d.%d] ", ippLib->Version, ippLib->major, ippLib->minor, ippLib->build, ippLib->majorBuild);
    printf("  name:    %s", ippLib->Name);
    printf("  date:    %s\n", ippLib->BuildDate);
    ippLib = ippdcGetLibVersion();
    printf("  version: %s, [%d.%d.%d.%d] ", ippLib->Version, ippLib->major, ippLib->minor, ippLib->build, ippLib->majorBuild);
    printf("  name:    %s", ippLib->Name);
    printf("  date:    %s\n", ippLib->BuildDate);

    return 0;
}
